diff --git a/Modules/Segmentation/Watersheds/include/itkWatershedSegmenter.hxx b/Modules/Segmentation/Watersheds/include/itkWatershedSegmenter.hxx
index cf1aa0116c..a301227f42 100644
--- a/Modules/Segmentation/Watersheds/include/itkWatershedSegmenter.hxx
+++ b/Modules/Segmentation/Watersheds/include/itkWatershedSegmenter.hxx
@@ -36,15 +36,16 @@ namespace watershed
   ----------------------------------------------------------------------------
 */
 
-template< typename TInputImage >
-Segmenter< TInputImage >::~Segmenter()
+template <typename TInputImage>
+Segmenter<TInputImage>::~Segmenter()
 {
   delete[] m_Connectivity.index;
   delete[] m_Connectivity.direction;
 }
 
-template< typename TInputImage >
-void Segmenter< TInputImage >::GenerateData()
+template <typename TInputImage>
+void
+Segmenter<TInputImage>::GenerateData()
 {
   //
   // Allocate all the necessary temporary data structures and variables that
@@ -54,17 +55,17 @@ void Segmenter< TInputImage >::GenerateData()
   unsigned int i;
 
   this->UpdateProgress(0.0);
-  if ( m_DoBoundaryAnalysis == false )
-    {
+  if (m_DoBoundaryAnalysis == false)
+  {
     this->GetSegmentTable()->Clear();
     this->SetCurrentLabel(1);
-    }
+  }
 
   flat_region_table_t flatRegions;
 
-  typename InputImageType::Pointer input   = this->GetInputImage();
+  typename InputImageType::Pointer  input = this->GetInputImage();
   typename OutputImageType::Pointer output = this->GetOutputImage();
-  typename BoundaryType::Pointer boundary  = this->GetBoundary();
+  typename BoundaryType::Pointer    boundary = this->GetBoundary();
 
   // ------------------------------------------------------------------------
   //
@@ -88,31 +89,30 @@ void Segmenter< TInputImage >::GenerateData()
   // out a pixel when we threshold so that we can construct the retaining wall
   // along those faces.
   //
-  ImageRegionType regionToProcess       = output->GetRequestedRegion();
+  ImageRegionType regionToProcess = output->GetRequestedRegion();
   ImageRegionType largestPossibleRegion = this->GetLargestPossibleRegion();
-  ImageRegionType thresholdImageRegion  = regionToProcess;
-  ImageRegionType thresholdLargestPossibleRegion =
-    this->GetLargestPossibleRegion();
+  ImageRegionType thresholdImageRegion = regionToProcess;
+  ImageRegionType thresholdLargestPossibleRegion = this->GetLargestPossibleRegion();
 
   // First we have to find the boundaries and adjust the threshold image size
   typename ImageRegionType::IndexType tidx = thresholdImageRegion.GetIndex();
-  typename ImageRegionType::SizeType tsz = thresholdImageRegion.GetSize();
+  typename ImageRegionType::SizeType  tsz = thresholdImageRegion.GetSize();
   typename ImageRegionType::IndexType tlidx = thresholdLargestPossibleRegion.GetIndex();
-  typename ImageRegionType::SizeType tlsz = thresholdLargestPossibleRegion.GetSize();
-  for ( i = 0; i < ImageDimension; ++i )
-    {
-    ImageRegionType reg;
+  typename ImageRegionType::SizeType  tlsz = thresholdLargestPossibleRegion.GetSize();
+  for (i = 0; i < ImageDimension; ++i)
+  {
+    ImageRegionType                     reg;
     typename ImageRegionType::IndexType idx = regionToProcess.GetIndex();
-    typename ImageRegionType::SizeType sz  = regionToProcess.GetSize();
+    typename ImageRegionType::SizeType  sz = regionToProcess.GetSize();
 
     // Set LOW face
     idx[i] = regionToProcess.GetIndex()[i];
-    sz[i]  = 1;
+    sz[i] = 1;
     reg.SetSize(sz);
     reg.SetIndex(idx);
 
-    if ( reg.GetIndex()[i] == largestPossibleRegion.GetIndex()[i] )
-      {
+    if (reg.GetIndex()[i] == largestPossibleRegion.GetIndex()[i])
+    {
       // This is facing a true data set boundary
       tsz[i] += 1; // we need to pad our threshold image on this face
       tidx[i] -= 1;
@@ -120,34 +120,33 @@ void Segmenter< TInputImage >::GenerateData()
       tlidx[i] -= 1;
 
       boundary->SetValid(false, i, 0);
-      }
+    }
     else
-      {
+    {
       // This is an overlap with another data chunk in the data set
       // Mark this boundary face as valid.
       boundary->SetValid(true, i, 0);
-      }
+    }
 
     // Set HIGH face
-    idx[i] = ( regionToProcess.GetIndex()[i] + regionToProcess.GetSize()[i] ) - 1;
+    idx[i] = (regionToProcess.GetIndex()[i] + regionToProcess.GetSize()[i]) - 1;
     reg.SetSize(sz);
     reg.SetIndex(idx);
-    if ( ( reg.GetIndex()[i] + reg.GetSize()[i] )
-         == ( largestPossibleRegion.GetIndex()[i]
-              + largestPossibleRegion.GetSize()[i] ) )
-      {
+    if ((reg.GetIndex()[i] + reg.GetSize()[i]) ==
+        (largestPossibleRegion.GetIndex()[i] + largestPossibleRegion.GetSize()[i]))
+    {
       // This is facing a true data set boundary
       tsz[i] += 1;  // we need to pad our threshold image on this face
       tlsz[i] += 1; // we need to pad our threshold image on this face
       boundary->SetValid(false, i, 1);
-      }
+    }
     else
-      {
+    {
       // This is an overlap with another data chunk in the data set
       // Mark this face as valid in the boundary.
       boundary->SetValid(true, i, 1);
-      }
     }
+  }
   thresholdImageRegion.SetSize(tsz);
   thresholdImageRegion.SetIndex(tidx);
   thresholdLargestPossibleRegion.SetSize(tlsz);
@@ -177,30 +176,37 @@ void Segmenter< TInputImage >::GenerateData()
   Self::MinMax(input, regionToProcess, minimum, maximum);
   // cap the maximum in the image so that we can always define a pixel
   // value that is one greater than the maximum value in the image.
-  if ( NumericTraits< InputPixelType >::IsInteger
+  if (NumericTraits<InputPixelType>::IsInteger
+        // clang-format off
 CLANG_PRAGMA_PUSH
 CLANG_SUPPRESS_Wfloat_equal
-       && maximum == NumericTraits< InputPixelType >::max() )
+      // clang-format on
+      && maximum == NumericTraits<InputPixelType>::max())
+    // clang-format off
 CLANG_PRAGMA_POP
+    // clang-format on
     {
-    maximum -= NumericTraits< InputPixelType >::OneValue();
+      maximum -= NumericTraits<InputPixelType>::OneValue();
     }
   // threshold the image.
-  Self::Threshold( thresholdImage, input, regionToProcess, regionToProcess,
-                   static_cast< InputPixelType >( ( m_Threshold * ( maximum - minimum ) ) + minimum ) );
+  Self::Threshold(thresholdImage,
+                  input,
+                  regionToProcess,
+                  regionToProcess,
+                  static_cast<InputPixelType>((m_Threshold * (maximum - minimum)) + minimum));
 
   //
   // Redefine the regionToProcess in terms of the threshold image.  The region
   // to  process represents all the pixels contained within the 1 pixel padded
   // boundary of the threshold image.
   //
-  typename ImageRegionType::SizeType irsz;
+  typename ImageRegionType::SizeType  irsz;
   typename ImageRegionType::IndexType iridx;
-  for ( i = 0; i < ImageDimension; ++i )
-    {
-    irsz[i]  = thresholdImageRegion.GetSize()[i] - 2;
+  for (i = 0; i < ImageDimension; ++i)
+  {
+    irsz[i] = thresholdImageRegion.GetSize()[i] - 2;
     iridx[i] = thresholdImageRegion.GetIndex()[i] + 1;
-    }
+  }
   regionToProcess.SetIndex(iridx);
   regionToProcess.SetSize(irsz);
 
@@ -222,7 +228,7 @@ CLANG_PRAGMA_POP
   // At this point we are ready to define the output
   // buffer and allocate memory for the output image.
   //
-  output->SetBufferedRegion( thresholdImage->GetBufferedRegion() );
+  output->SetBufferedRegion(thresholdImage->GetBufferedRegion());
   output->Allocate();
   Self::SetOutputImageValues(output, output->GetBufferedRegion(), Self::NULL_LABEL);
 
@@ -231,23 +237,26 @@ CLANG_PRAGMA_POP
   // flow at the boundaries from the requested region of the threshold
   // image.
   //
-  typename BoundaryType::IndexType b_idx;
-  ImageRegionType reg_b;
+  typename BoundaryType::IndexType    b_idx;
+  ImageRegionType                     reg_b;
   typename ImageRegionType::IndexType idx_b;
-  typename ImageRegionType::SizeType sz_b;
+  typename ImageRegionType::SizeType  sz_b;
 
-  for ( b_idx.first = 0; b_idx.first < ImageDimension; ++b_idx.first )
+  for (b_idx.first = 0; b_idx.first < ImageDimension; ++b_idx.first)
+  {
+    for (b_idx.second = 0; b_idx.second < 2; ++b_idx.second)
     {
-    for ( b_idx.second = 0; b_idx.second < 2; ++b_idx.second )
+      if (boundary->GetValid(b_idx) == false)
       {
-      if ( boundary->GetValid(b_idx) == false ) { continue; }
+        continue;
+      }
       idx_b = thresholdImage->GetRequestedRegion().GetIndex();
       sz_b = thresholdImage->GetRequestedRegion().GetSize();
 
-      if ( b_idx.second == 1 ) // HIGH face must adjust start index
-        {
+      if (b_idx.second == 1) // HIGH face must adjust start index
+      {
         idx_b[b_idx.first] += sz_b[b_idx.first] - 1;
-        }
+      }
 
       sz_b[b_idx.first] = 1;
 
@@ -258,8 +267,8 @@ CLANG_PRAGMA_POP
       boundary->GetFace(b_idx)->SetRequestedRegion(reg_b);
       boundary->GetFace(b_idx)->SetBufferedRegion(reg_b);
       boundary->GetFace(b_idx)->Allocate();
-      }
     }
+  }
   this->UpdateProgress(0.1);
 
   //
@@ -268,12 +277,11 @@ CLANG_PRAGMA_POP
   // flat-region connectivity) and constructs the appropriate Boundary
   // data structures.
   //
-  if ( m_DoBoundaryAnalysis == true )
-    {
+  if (m_DoBoundaryAnalysis == true)
+  {
     this->InitializeBoundary();
-    this->AnalyzeBoundaryFlow(thresholdImage, flatRegions, maximum
-                              + NumericTraits< InputPixelType >::OneValue());
-    }
+    this->AnalyzeBoundaryFlow(thresholdImage, flatRegions, maximum + NumericTraits<InputPixelType>::OneValue());
+  }
 
   this->UpdateProgress(0.2);
 
@@ -284,145 +292,149 @@ CLANG_PRAGMA_POP
   // All overlap boundary information will be overwritten, but is no longer
   // needed now.
   //
-  this->BuildRetainingWall(thresholdImage,
-                           thresholdImage->GetBufferedRegion(),
-                           maximum + NumericTraits< InputPixelType >::OneValue());
+  this->BuildRetainingWall(
+    thresholdImage, thresholdImage->GetBufferedRegion(), maximum + NumericTraits<InputPixelType>::OneValue());
 
   //
   // Label all the local minima pixels in the image.  This function also
   // labels flat regions, defined as regions where connected pixels all have
   // the same value.
   //
-  this->LabelMinima(thresholdImage, thresholdImage->GetRequestedRegion(),
-                    flatRegions, maximum + NumericTraits< InputPixelType >::OneValue());
+  this->LabelMinima(thresholdImage,
+                    thresholdImage->GetRequestedRegion(),
+                    flatRegions,
+                    maximum + NumericTraits<InputPixelType>::OneValue());
   this->UpdateProgress(0.3);
 
-  this->GradientDescent( thresholdImage, thresholdImage->GetRequestedRegion() );
+  this->GradientDescent(thresholdImage, thresholdImage->GetRequestedRegion());
   this->UpdateProgress(0.4);
 
-  this->DescendFlatRegions( flatRegions, thresholdImage->GetRequestedRegion() );
+  this->DescendFlatRegions(flatRegions, thresholdImage->GetRequestedRegion());
   this->UpdateProgress(0.5);
 
-  this->UpdateSegmentTable( thresholdImage, thresholdImage->GetRequestedRegion() );
+  this->UpdateSegmentTable(thresholdImage, thresholdImage->GetRequestedRegion());
   this->UpdateProgress(0.6);
 
-  if ( m_DoBoundaryAnalysis == true )
-          {  this->CollectBoundaryInformation(flatRegions); }
+  if (m_DoBoundaryAnalysis == true)
+  {
+    this->CollectBoundaryInformation(flatRegions);
+  }
   this->UpdateProgress(0.7);
 
-  if ( m_SortEdgeLists == true )
-          {  this->GetSegmentTable()->SortEdgeLists(); }
+  if (m_SortEdgeLists == true)
+  {
+    this->GetSegmentTable()->SortEdgeLists();
+  }
   this->UpdateProgress(0.8);
 
   this->GetSegmentTable()->SetMaximumDepth(maximum - minimum);
   this->UpdateProgress(1.0);
 }
 
-template< typename TInputImage >
-void Segmenter< TInputImage >
-::CollectBoundaryInformation(flat_region_table_t & flatRegions)
+template <typename TInputImage>
+void
+Segmenter<TInputImage>::CollectBoundaryInformation(flat_region_table_t & flatRegions)
 {
   typename OutputImageType::Pointer output = this->GetOutputImage();
-  typename BoundaryType::Pointer boundary  = this->GetBoundary();
+  typename BoundaryType::Pointer    boundary = this->GetBoundary();
 
-  ImageRegionIterator< typename BoundaryType::face_t > faceIt;
-  ImageRegionIterator< OutputImageType >                   labelIt;
+  ImageRegionIterator<typename BoundaryType::face_t> faceIt;
+  ImageRegionIterator<OutputImageType>               labelIt;
 
-  typename BoundaryType::face_t::Pointer face;
-  typename BoundaryType::flat_hash_t           * flats;
+  typename BoundaryType::face_t::Pointer       face;
+  typename BoundaryType::flat_hash_t *         flats;
   typename BoundaryType::flat_hash_t::iterator flats_it;
-  typename BoundaryType::flat_region_t flr;
-  typename flat_region_table_t::iterator flrt_it;
+  typename BoundaryType::flat_region_t         flr;
+  typename flat_region_table_t::iterator       flrt_it;
 
   typename BoundaryType::IndexType idx;
-  ImageRegionType region;
+  ImageRegionType                  region;
 
-  for ( idx.first = 0; idx.first < ImageDimension; ( idx.first )++ )
+  for (idx.first = 0; idx.first < ImageDimension; (idx.first)++)
+  {
+    for (idx.second = 0; idx.second < 2; (idx.second)++)
     {
-    for ( idx.second = 0; idx.second < 2; ( idx.second )++ )
+      if (boundary->GetValid(idx) == false)
       {
-      if ( boundary->GetValid(idx) == false ) { continue; }
+        continue;
+      }
 
-      face  = boundary->GetFace(idx);
+      face = boundary->GetFace(idx);
       flats = boundary->GetFlatHash(idx);
       region = face->GetRequestedRegion();
 
       // Grab all the labels of the boundary pixels.
-      faceIt = ImageRegionIterator< typename BoundaryType::face_t >(face,
-                                                                        region);
-      labelIt = ImageRegionIterator< OutputImageType >(output, region);
+      faceIt = ImageRegionIterator<typename BoundaryType::face_t>(face, region);
+      labelIt = ImageRegionIterator<OutputImageType>(output, region);
       faceIt.GoToBegin();
       labelIt.GoToBegin();
-      while ( !faceIt.IsAtEnd() )
-        {
-        faceIt.Value(). label = labelIt.Get();
+      while (!faceIt.IsAtEnd())
+      {
+        faceIt.Value().label = labelIt.Get();
 
         // Is this a flat region that flows out?
-        flrt_it = flatRegions.find( labelIt.Get() );
-        if ( faceIt.Get().flow != NULL_FLOW
-             && flrt_it != flatRegions.end() )
-          {
+        flrt_it = flatRegions.find(labelIt.Get());
+        if (faceIt.Get().flow != NULL_FLOW && flrt_it != flatRegions.end())
+        {
           // Have we already entered this
           // flat region into the boundary?
-          flats_it = flats->find( labelIt.Get() );
-          if ( flats_it == flats->end() )  // NO
-            {
-            flr.bounds_min = ( *flrt_it ).second.bounds_min;
-            flr.min_label  = *( ( *flrt_it ).second.min_label_ptr );
-            flr.value      = ( *flrt_it ).second.value;
-            flr.offset_list.push_back(
-              face->ComputeOffset( faceIt.GetIndex() ) );
-            flats->insert(
-              BoundaryFlatHashValueType(labelIt.Get(), flr) );
+          flats_it = flats->find(labelIt.Get());
+          if (flats_it == flats->end()) // NO
+          {
+            flr.bounds_min = (*flrt_it).second.bounds_min;
+            flr.min_label = *((*flrt_it).second.min_label_ptr);
+            flr.value = (*flrt_it).second.value;
+            flr.offset_list.push_back(face->ComputeOffset(faceIt.GetIndex()));
+            flats->insert(BoundaryFlatHashValueType(labelIt.Get(), flr));
             flr.offset_list.clear();
-            }
+          }
           else // YES
-            {
-            ( *flats_it ).second.offset_list.push_back( face->ComputeOffset( faceIt.GetIndex() ) );
-            }
+          {
+            (*flats_it).second.offset_list.push_back(face->ComputeOffset(faceIt.GetIndex()));
           }
+        }
 
         ++faceIt;
         ++labelIt;
-        }
       }
     }
+  }
 }
 
-template< typename TInputImage >
-void Segmenter< TInputImage >
-::InitializeBoundary()
+template <typename TInputImage>
+void
+Segmenter<TInputImage>::InitializeBoundary()
 {
-  ImageRegionIterator< typename BoundaryType::face_t > faceIt;
   typename BoundaryType::face_t::Pointer face;
-  typename BoundaryType::face_pixel_t fps;
-  BoundaryIndexType idx;
+  typename BoundaryType::face_pixel_t    fps;
+  BoundaryIndexType                      idx;
 
-  fps.flow  = NULL_FLOW;
+  fps.flow = NULL_FLOW;
   fps.label = NULL_LABEL;
 
-  for ( idx.first = 0; idx.first < ImageDimension; ++( idx.first ) )
+  for (idx.first = 0; idx.first < ImageDimension; ++(idx.first))
+  {
+    for (idx.second = 0; idx.second < 2; ++(idx.second))
     {
-    for ( idx.second = 0; idx.second < 2; ++( idx.second ) )
+      if (this->GetBoundary()->GetValid(idx) == false)
       {
-      if ( this->GetBoundary()->GetValid(idx) == false ) { continue; }
+        continue;
+      }
       this->GetBoundary()->GetFlatHash(idx)->clear();
       face = this->GetBoundary()->GetFace(idx);
-      faceIt = ImageRegionIterator< typename BoundaryType::face_t >
-                 ( face, face->GetBufferedRegion() );
-      for ( faceIt.GoToBegin(); !faceIt.IsAtEnd(); ++faceIt )
-        {
-        faceIt.Set(fps);
-        }
+      if (face != nullptr)
+      {
+        face->FillBuffer(fps);
       }
     }
+  }
 }
 
-template< typename TInputImage >
-void Segmenter< TInputImage >
-::AnalyzeBoundaryFlow(InputImageTypePointer thresholdImage,
-                      flat_region_table_t & flatRegions,
-                      InputPixelType max)
+template <typename TInputImage>
+void
+Segmenter<TInputImage>::AnalyzeBoundaryFlow(InputImageTypePointer thresholdImage,
+                                            flat_region_table_t & flatRegions,
+                                            InputPixelType        max)
 {
   //
   // NOTE: For ease of initial implementation, this method does
@@ -431,194 +443,193 @@ void Segmenter< TInputImage >
   unsigned int nCenter, i, nPos, cPos;
   bool         isSteepest;
 
-  ConstNeighborhoodIterator< InputImageType >              searchIt;
-  NeighborhoodIterator< OutputImageType >                  labelIt;
-  ImageRegionIterator< typename BoundaryType::face_t > faceIt;
+  ConstNeighborhoodIterator<InputImageType>          searchIt;
+  NeighborhoodIterator<OutputImageType>              labelIt;
+  ImageRegionIterator<typename BoundaryType::face_t> faceIt;
 
-  BoundaryIndexType idx;
-  ImageRegionType   region;
-  typename ConstNeighborhoodIterator< InputImageType >::RadiusType rad;
+  BoundaryIndexType                                              idx;
+  ImageRegionType                                                region;
+  typename ConstNeighborhoodIterator<InputImageType>::RadiusType rad;
 
   typename BoundaryType::face_pixel_t fps;
-  flat_region_t tempFlatRegion;
+  flat_region_t                       tempFlatRegion;
 
-  typename OutputImageType::Pointer output   = this->GetOutputImage();
-  typename BoundaryType::Pointer boundary = this->GetBoundary();
+  typename OutputImageType::Pointer output = this->GetOutputImage();
+  typename BoundaryType::Pointer    boundary = this->GetBoundary();
 
-  for ( i = 0; i < ImageDimension; ++i )
-    {
+  for (i = 0; i < ImageDimension; ++i)
+  {
     rad[i] = 1;
-    }
+  }
   fps.label = NULL_LABEL;
 
   EquivalencyTable::Pointer eqTable = EquivalencyTable::New();
 
   // Process each boundary region.
-  for ( idx.first = 0; idx.first < ImageDimension; ++( idx.first ) )
+  for (idx.first = 0; idx.first < ImageDimension; ++(idx.first))
+  {
+    for (idx.second = 0; idx.second < 2; ++(idx.second))
     {
-    for ( idx.second = 0; idx.second < 2; ++( idx.second ) )
-      {
       // Skip irrelevant boundaries
-      if ( boundary->GetValid(idx) == false ) { continue; }
+      if (boundary->GetValid(idx) == false)
+      {
+        continue;
+      }
 
       typename BoundaryType::face_t::Pointer face = boundary->GetFace(idx);
       region = face->GetRequestedRegion();
 
-      searchIt =
-        ConstNeighborhoodIterator< InputImageType >(rad, thresholdImage, region);
-      labelIt = NeighborhoodIterator< OutputImageType >(rad, output, region);
-      faceIt  = ImageRegionIterator< typename BoundaryType::face_t >(face, region);
+      searchIt = ConstNeighborhoodIterator<InputImageType>(rad, thresholdImage, region);
+      labelIt = NeighborhoodIterator<OutputImageType>(rad, output, region);
+      faceIt = ImageRegionIterator<typename BoundaryType::face_t>(face, region);
 
       nCenter = searchIt.Size() / 2;
       searchIt.GoToBegin();
       labelIt.GoToBegin();
 
-      if ( ( idx ).second == 0 )
-        {
+      if ((idx).second == 0)
+      {
         // Low face
-        cPos = m_Connectivity.index[( idx ).first];
-        }
+        cPos = m_Connectivity.index[(idx).first];
+      }
       else
-        {
+      {
         // High face
-        cPos = m_Connectivity.index[( ImageDimension - 1 )
-                                    + ( ImageDimension - ( idx ).first )];
-        }
+        cPos = m_Connectivity.index[(ImageDimension - 1) + (ImageDimension - (idx).first)];
+      }
 
-      while ( !searchIt.IsAtEnd() )
-        {
+      while (!searchIt.IsAtEnd())
+      {
         // Is this a flat connection?
-        if ( Math::AlmostEquals( searchIt.GetPixel(nCenter), searchIt.GetPixel(cPos) ) )
-          {
+        if (Math::AlmostEquals(searchIt.GetPixel(nCenter), searchIt.GetPixel(cPos)))
+        {
           // Fill in the boundary flow information.
           // Labels will be collected later.
-          fps.flow   = static_cast< short >( cPos );
+          fps.flow = static_cast<short>(cPos);
           faceIt.Set(fps);
 
           // Are we touching flat regions
           // that have already been labeled?
-          bool _labeled    = false;
-          bool _connected  = false;
-          for ( i = 0; i < m_Connectivity.size; i++ )
-            {
+          bool _labeled = false;
+          bool _connected = false;
+          for (i = 0; i < m_Connectivity.size; i++)
+          {
             nPos = m_Connectivity.index[i];
-            if (   Math::AlmostEquals( searchIt.GetPixel(nCenter), searchIt.GetPixel(nPos) )
-                   && labelIt.GetPixel(nPos) != Self::NULL_LABEL
-                   && labelIt.GetPixel(nPos) != labelIt.GetPixel(nCenter)
-                   )
-              {
+            if (Math::AlmostEquals(searchIt.GetPixel(nCenter), searchIt.GetPixel(nPos)) &&
+                labelIt.GetPixel(nPos) != Self::NULL_LABEL && labelIt.GetPixel(nPos) != labelIt.GetPixel(nCenter))
+            {
               _connected = true;
-              if ( _labeled == false )
-                {
-                labelIt.SetPixel( nCenter,
-                                  labelIt.GetPixel(nPos) );
+              if (_labeled == false)
+              {
+                labelIt.SetPixel(nCenter, labelIt.GetPixel(nPos));
                 _labeled = true;
-                }
+              }
               else
-                {
-                eqTable->Add( labelIt.GetPixel(nCenter), labelIt.GetPixel(nPos) );
-                }
+              {
+                eqTable->Add(labelIt.GetPixel(nCenter), labelIt.GetPixel(nPos));
               }
             }
-          if ( _connected == false ) // Add a new flat region.
-            {
+          }
+          if (_connected == false) // Add a new flat region.
+          {
             labelIt.SetPixel(nCenter, m_CurrentLabel);
 
             // Add a flat region to the (global) flat region table
-            tempFlatRegion.bounds_min    = max;
-            tempFlatRegion.min_label_ptr = output->GetBufferPointer()
-                                           + output->ComputeOffset( labelIt.GetIndex() );
-            tempFlatRegion.value         = searchIt.GetPixel(nCenter);
+            tempFlatRegion.bounds_min = max;
+            tempFlatRegion.min_label_ptr = output->GetBufferPointer() + output->ComputeOffset(labelIt.GetIndex());
+            tempFlatRegion.value = searchIt.GetPixel(nCenter);
             tempFlatRegion.is_on_boundary = true;
-            flatRegions[m_CurrentLabel]  = tempFlatRegion;
+            flatRegions[m_CurrentLabel] = tempFlatRegion;
 
             m_CurrentLabel++;
-            }
           }
-        else  // Is cPos the path of steepest descent?
+        }
+        else // Is cPos the path of steepest descent?
+        {
+          if (searchIt.GetPixel(cPos) < searchIt.GetPixel(nCenter))
           {
-          if ( searchIt.GetPixel(cPos) < searchIt.GetPixel(nCenter) )
-            {
             isSteepest = true;
-            for ( i = 0; i < m_Connectivity.size; i++ )
-              {
+            for (i = 0; i < m_Connectivity.size; i++)
+            {
               nPos = m_Connectivity.index[i];
-              if ( searchIt.GetPixel(nPos) < searchIt.GetPixel(cPos) )
-                {
+              if (searchIt.GetPixel(nPos) < searchIt.GetPixel(cPos))
+              {
                 isSteepest = false;
                 break;
-                }
               }
             }
-          else { isSteepest = false; }
+          }
+          else
+          {
+            isSteepest = false;
+          }
 
-          if ( isSteepest == true )
-            {
+          if (isSteepest == true)
+          {
             // Label this pixel. It will be safely treated as a local
             // minimum by the rest of the segmentation algorithm.
             labelIt.SetPixel(nCenter, m_CurrentLabel);
 
             // Add the connectivity information
             // to the boundary data structure.
-            fps.flow  = static_cast< short >( cPos );
+            fps.flow = static_cast<short>(cPos);
             faceIt.Set(fps);
 
             // Since we've labeled this pixel, we need to check to
             // make sure this is not also a flat region.  If it is,
             // then it must be entered into the flat region table
             // or we could have problems later on.
-            for ( i = 0; i < m_Connectivity.size; i++ )
-              {
+            for (i = 0; i < m_Connectivity.size; i++)
+            {
               nPos = m_Connectivity.index[i];
-              if ( Math::AlmostEquals( searchIt.GetPixel(nPos),
-                   searchIt.GetPixel(nCenter) ) )
-                {
+              if (Math::AlmostEquals(searchIt.GetPixel(nPos), searchIt.GetPixel(nCenter)))
+              {
                 tempFlatRegion.bounds_min = max;
-                tempFlatRegion.min_label_ptr =
-                  output->GetBufferPointer()
-                  + output->ComputeOffset( labelIt.GetIndex() );
-                tempFlatRegion.value =
-                  searchIt.GetPixel(nCenter);
+                tempFlatRegion.min_label_ptr = output->GetBufferPointer() + output->ComputeOffset(labelIt.GetIndex());
+                tempFlatRegion.value = searchIt.GetPixel(nCenter);
                 tempFlatRegion.is_on_boundary = false;
                 flatRegions[m_CurrentLabel] = tempFlatRegion;
                 break;
-                }
               }
-            m_CurrentLabel++;
             }
+            m_CurrentLabel++;
           }
+        }
 
         ++searchIt;
         ++labelIt;
         ++faceIt;
-        }
       }
     }
+  }
 
   eqTable->Flatten();
 
   // Now relabel any equivalent regions in the boundaries.
-  for ( idx.first = 0; idx.first < ImageDimension; ++( idx.first ) )
+  for (idx.first = 0; idx.first < ImageDimension; ++(idx.first))
+  {
+    for (idx.second = 0; idx.second < 2; ++(idx.second))
     {
-    for ( idx.second = 0; idx.second < 2; ++( idx.second ) )
-      {
       // Skip irrelevant boundaries
-      if ( boundary->GetValid(idx) == false ) { continue; }
+      if (boundary->GetValid(idx) == false)
+      {
+        continue;
+      }
 
       typename BoundaryType::face_t::Pointer face = boundary->GetFace(idx);
       region = face->GetRequestedRegion();
 
       Self::RelabelImage(output, region, eqTable);
-      }
     }
+  }
 
   // Merge the flat regions in the table
   Self::MergeFlatRegions(flatRegions, eqTable);
 }
 
-template< typename TInputImage >
-void Segmenter< TInputImage >
-::GenerateConnectivity()
+template <typename TInputImage>
+void
+Segmenter<TInputImage>::GenerateConnectivity()
 {
   unsigned int i, j, nSize, nCenter, stride;
   int          d;
@@ -634,44 +645,45 @@ void Segmenter< TInputImage >
   //
   // Algorithms assume this order to the connectivity.
   //
-  typename ConstNeighborhoodIterator< InputImageType >::RadiusType rad;
-  for ( i = 0; i < ImageDimension; ++i )
-    {
+  typename ConstNeighborhoodIterator<InputImageType>::RadiusType rad;
+  for (i = 0; i < ImageDimension; ++i)
+  {
     rad[i] = 1;
-    }
-  ConstNeighborhoodIterator< InputImageType > it( rad, this->GetInputImage(),
-                                                  this->GetInputImage()->GetRequestedRegion() );
-  nSize   = it.Size();
+  }
+  ConstNeighborhoodIterator<InputImageType> it(rad, this->GetInputImage(), this->GetInputImage()->GetRequestedRegion());
+  nSize = it.Size();
   nCenter = nSize >> 1;
 
-  for ( i = 0; i < m_Connectivity.size; i++ ) // initialize move list
+  for (i = 0; i < m_Connectivity.size; i++) // initialize move list
+  {
+    for (j = 0; j < ImageDimension; j++)
     {
-    for ( j = 0; j < ImageDimension; j++ )
-      {
       m_Connectivity.direction[i][j] = 0;
-      }
     }
+  }
   i = 0;
-  for ( d = ImageDimension - 1; d >= 0; d-- )
-    {
+  for (d = ImageDimension - 1; d >= 0; d--)
+  {
     stride = it.GetStride(d);
     m_Connectivity.index[i] = nCenter - stride;
     m_Connectivity.direction[i][d] = -1;
     i++;
-    }
-  for ( d = 0; d < static_cast< int >( ImageDimension ); d++ )
-    {
+  }
+  for (d = 0; d < static_cast<int>(ImageDimension); d++)
+  {
     stride = it.GetStride(d);
     m_Connectivity.index[i] = nCenter + stride;
     m_Connectivity.direction[i][d] = 1;
     i++;
-    }
+  }
 }
 
-template< typename TInputImage >
-void Segmenter< TInputImage >
-::LabelMinima(InputImageTypePointer img, ImageRegionType region,
-              typename Self::flat_region_table_t & flatRegions, InputPixelType Max)
+template <typename TInputImage>
+void
+Segmenter<TInputImage>::LabelMinima(InputImageTypePointer                img,
+                                    ImageRegionType                      region,
+                                    typename Self::flat_region_table_t & flatRegions,
+                                    InputPixelType                       Max)
 {
   unsigned int   i, nSize, nCenter, nPos = 0;
   bool           foundSinglePixelMinimum, foundFlatRegion;
